# NOTE: Derived from blib/lib/Graphics/ColorPicker.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Graphics::ColorPicker;

#line 984 "blib/lib/Graphics/ColorPicker.pm (autosplit into blib/lib/auto/Graphics/ColorPicker/jslib.al)"
################################################
# javascript xy resolver library
#
# input:	none
# return:	library text
#
sub jslib {
  return '' if ($obfuscate && (caller(1))[3] !~ /::msie_frame/);
  return q|
// copyright 2002
// Michael A. Robinton, michael@bizsystems.com
var r;
var g;
var b;
colorpluck = function() {
  pluckXY(arguments[0]);
  if ( px > blim && py > blim ) return(window._digits.flipc24m());
  px -= mv;
  py = mv - py;
  r = color_R(px,py);
  if (r > 255) return true; // have to return something
  if (color_GB(px,py)) return true; // ditto
  if (window._picker.c24flip != 0) {
    r = 255 - r;
    g = 255 - g;
    b = 255 - b;
  }
  setcolor(r,g,b);
  return true;
}

var con = 2.236067977;
color_R = function(x,y) {
  if (x < 0) x = -x;
   r = y + (x/2);
  if (r < 0) return 0;
  r = (con * r * sf) + 1;
  r >>= 1;
  if (r == 256) return 255;
  return r;
}

color_GB = function(x,y) {
  y = -y * sf;
  x *= sf;
  b = y + x/2;
  g = y - x/2;
  if (b < 0) b = 0;
  if (g < 0) g = 0;
  if (x < 0) {
    g = b - x;
  } else {
    b = g + x;
  }
  b = (con*b + 1) >>1;
  g = (con*g + 1) >>1;
  if (g > 256) return g;
  if (b > 256) return b;
  if (g > 255) g = 255;
  if (b > 255) b = 255;
  return 0;
}

greypluck = function() {
  pluckXY(arguments[0]);
  if (py > 255) py = 255;
  py = 255 - py;
  setcolor(py,py,py);
  return true;
}

pluckXY = function(skip) {
  if ( ! skip ) {
    var xy = window._data.document.location.search;
    var qloc = xy.lastIndexOf('?') + 1;
    var cloc = xy.lastIndexOf(',');
    px = bound(xy.substring(qloc,cloc));
    py = bound(xy.substring(cloc+1,xy.length));
  }
}

bound = function(n) {
  n = 0 + n;
  if (isNaN(n)) return 0;
  if (n < 0) n = 0;
  return n;
}

setcolor = function(r,g,b) {
  with (window._digits) {
  rgb[0] = r;
  rgb[1] = g;
  rgb[2] = b;
  setrgb();  
  sethex();
  }
  return true;
}

|;
}

# end of Graphics::ColorPicker::jslib
1;
