# NOTE: Derived from blib/lib/Graphics/ColorPicker.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Graphics::ColorPicker;

#line 309 "blib/lib/Graphics/ColorPicker.pm (autosplit into blib/lib/auto/Graphics/ColorPicker/frames.al)"
################################################
# return new frames page
#
# input:	false = 24 million colors, true = web safe
# returns:	top window html frames text
#
sub frames {
  my ($websafe) = @_;
  my $jsl = ($server_only) ? '' : '&jsl=1';
  my $hex = ($ENV{QUERY_STRING} =~ /hex=[\#]*([0-9a-fA-F]{6})/)
	? "?what=init&hex=$1" : '?what=init';

  my $head = q|<html>
<head>
<title>Color Picker - www.bizsystems.com</title>
<script language=javascript>
var uno = '';
var doce = '';
var blim;
var mv;
var px;
var py;
var pict;
var sf;
var out = 1;
function isOK() {
  if ((eval(out) < 1.2) | . '||' . q| (navigator.userAgent.indexOf('Opera') != -1)) {
    alert('Sorry, unsupported or flakey browser');
  }
}

</script>
<script language=javascript1.2>
  out = 1.2 // have javascript 1.2 or better|;

  $head .= q|
colorpluck = function(){pluckXY();if(px>blim&&py>blim){return(window._digits.flipc24m());}px-=mv;py=mv-py;scale();var g=Math.abs(px/2);var r=py+g;if(r<0)r=0;py=-py;var b=py-g;if(b<0)b=0;if(px<0){g=b-px;}else{g=b;b=g+px;}out = window._digits;out.rgb[0] = parseInt(r);out.rgb[1] = parseInt(g);out.rgb[2] = parseInt(b);if(window._picker.c24flip!=0){out.rgb[0] = 255 - out.rgb[0];out.rgb[1] = 255 - out.rgb[1];out.rgb[2] = 255 - out.rgb[2];}out.setrgb();out.sethex();}
greypluck = function(){pluckXY();py=255-py;out = window._digits;out.rgb[0] = py;out.rgb[1] = py;out.rgb[2] = py;out.setrgb();out.sethex();}
pluckXY = function(){var xy=window._data.document.location.search;var qloc=xy.lastIndexOf('?')+1;var cloc=xy.lastIndexOf(',');px=xy.substring(qloc,cloc);py=xy.substring(cloc+1,xy.length);}  
scale = function(){px*=sf;py*=sf;}|
	if $obfuscate;

$head .= q|
</script>
|;

  my ($fmie,$umd) = &_force_mdown;
  my $gen_name = script_name;
  $_ = ( $obfuscate || $fmie || &env_dumb_browser )
	? $gen_name . '?what=msie'
	: 'javascript:\"' . $msie_frame . '\"';

  $head .= q|
<script language=javascript1.2 src=|. &script_name . q|?what=jslib></script>|
	if $jsl && ! $obfuscate;

  my $what = 'picker';
  if ( $websafe ) {
    $what = 'no_picker';
    $leftwidth = 0;
  }
  my $sc = 'no';	# scrolling -- normally no, yes for debug
  return $head . q|
</head>
<script language=javascript>
if (out == 1.2) {
  document.writeln('<frameset cols="| . $leftwidth . q|,*" border=0 onLoad="isOK();window._digits.init();">');
  document.writeln('  <frame name=_picker scrolling=| . $sc . q| marginheight=0 marginwidth=0 src=|. $gen_name . q|?what=|. $what . $jsl . q|>');
  document.writeln('  <frameset rows="0,85,*" border=0>');
  document.writeln("  <frame name=_data scrolling=| . $sc . q| marginheight=0 marginwidth=0 src='|. $gen_name . $hex . q|'>");
  document.writeln("  <frame name=_sample scrolling=| . $sc . q| marginheight=0 marginwidth=0 src='|. $_ . q|'>");
  document.writeln('  <frame name=_digits scrolling=| . $sc . q| marginheight=0 marginwidth=0 src=|. $gen_name . q|?what=digits|. $jsl . q|>');
  document.writeln('  </frameset>');
  document.writeln('</frameset>');
} else {

  document.writeln('<body bgcolor="#ffffcc"><center><font size=6 color=red>THIS APPLICATION REQUIRES A<BR>JAVASCRIPT 1.2 COMPLIANT BROWSER</FONT></center></body>');
}

</script>
<noscript>
<body bgcolor="#ffffff"><center><font size=6 color=red>YOU MUST ACTIVATE JAVASCRIPT 1.2<BR>OR BETTER TO USE THIS APPLICATION</FONT></center></body>
</noscript>
</html>
|;
}

# end of Graphics::ColorPicker::frames
1;
